Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselationhelpers.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -8,4 +8,5 @@
 #include <fstream>
 
+#include "info.hpp"
 #include "linkedcell.hpp"
 #include "log.hpp"
@@ -15,5 +16,7 @@
 #include "verbose.hpp"
 
-double DetGet(gsl_matrix * const A, const int inPlace) {
+double DetGet(gsl_matrix * const A, const int inPlace)
+{
+	Info FunctionInfo(__func__);
   /*
   inPlace = 1 => A is replaced with the LU decomposed copy.
@@ -45,4 +48,5 @@
 void GetSphere(Vector * const center, const Vector &a, const Vector &b, const Vector &c, const double RADIUS)
 {
+	Info FunctionInfo(__func__);
   gsl_matrix *A = gsl_matrix_calloc(3,3);
   double m11, m12, m13, m14;
@@ -77,5 +81,5 @@
 
   if (fabs(m11) < MYEPSILON)
-    eLog() << Verbose(0) << "ERROR: three points are colinear." << endl;
+    eLog() << Verbose(1) << "three points are colinear." << endl;
 
   center->x[0] =  0.5 * m12/ m11;
@@ -84,5 +88,5 @@
 
   if (fabs(a.Distance(center) - RADIUS) > MYEPSILON)
-    eLog() << Verbose(0) << "ERROR: The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl;
+    eLog() << Verbose(1) << "The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl;
 
   gsl_matrix_free(A);
@@ -111,8 +115,8 @@
     const double HalfplaneIndicator, const double AlternativeIndicator, const double alpha, const double beta, const double gamma, const double RADIUS, const double Umkreisradius)
 {
+	Info FunctionInfo(__func__);
   Vector TempNormal, helper;
   double Restradius;
   Vector OtherCenter;
-  Log() << Verbose(3) << "Begin of GetCenterOfSphere.\n";
   Center->Zero();
   helper.CopyVector(&a);
@@ -128,7 +132,7 @@
   Center->Scale(1./(sin(2.*alpha) + sin(2.*beta) + sin(2.*gamma)));
   NewUmkreismittelpunkt->CopyVector(Center);
-  Log() << Verbose(4) << "Center of new circumference is " << *NewUmkreismittelpunkt << ".\n";
+  Log() << Verbose(1) << "Center of new circumference is " << *NewUmkreismittelpunkt << ".\n";
   // Here we calculated center of circumscribing circle, using barycentric coordinates
-  Log() << Verbose(4) << "Center of circumference is " << *Center << " in direction " << *Direction << ".\n";
+  Log() << Verbose(1) << "Center of circumference is " << *Center << " in direction " << *Direction << ".\n";
 
   TempNormal.CopyVector(&a);
@@ -154,13 +158,12 @@
   TempNormal.Normalize();
   Restradius = sqrt(RADIUS*RADIUS - Umkreisradius*Umkreisradius);
-  Log() << Verbose(4) << "Height of center of circumference to center of sphere is " << Restradius << ".\n";
+  Log() << Verbose(1) << "Height of center of circumference to center of sphere is " << Restradius << ".\n";
   TempNormal.Scale(Restradius);
-  Log() << Verbose(4) << "Shift vector to sphere of circumference is " << TempNormal << ".\n";
+  Log() << Verbose(1) << "Shift vector to sphere of circumference is " << TempNormal << ".\n";
 
   Center->AddVector(&TempNormal);
-  Log() << Verbose(0) << "Center of sphere of circumference is " << *Center << ".\n";
+  Log() << Verbose(1) << "Center of sphere of circumference is " << *Center << ".\n";
   GetSphere(&OtherCenter, a, b, c, RADIUS);
-  Log() << Verbose(0) << "OtherCenter of sphere of circumference is " << OtherCenter << ".\n";
-  Log() << Verbose(3) << "End of GetCenterOfSphere.\n";
+  Log() << Verbose(1) << "OtherCenter of sphere of circumference is " << OtherCenter << ".\n";
 };
 
@@ -174,4 +177,5 @@
 void GetCenterofCircumcircle(Vector * const Center, const Vector &a, const Vector &b, const Vector &c)
 {
+	Info FunctionInfo(__func__);
   Vector helper;
   double alpha, beta, gamma;
@@ -186,7 +190,8 @@
   beta = M_PI - SideC.Angle(&SideA);
   gamma = M_PI - SideA.Angle(&SideB);
-  //Log() << Verbose(3) << "INFO: alpha = " << alpha/M_PI*180. << ", beta = " << beta/M_PI*180. << ", gamma = " << gamma/M_PI*180. << "." << endl;
-  if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON)
-    eLog() << Verbose(0) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl;
+  //Log() << Verbose(1) << "INFO: alpha = " << alpha/M_PI*180. << ", beta = " << beta/M_PI*180. << ", gamma = " << gamma/M_PI*180. << "." << endl;
+  if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON) {
+    eLog() << Verbose(1) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl;
+  }
 
   Center->Zero();
@@ -218,4 +223,5 @@
 double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection)
 {
+	Info FunctionInfo(__func__);
   Vector helper;
   double radius, alpha;
@@ -224,5 +230,5 @@
   // test whether new center is on the parameter circle's plane
   if (fabs(helper.ScalarProduct(&CirclePlaneNormal)) > HULLEPSILON) {
-    eLog() << Verbose(0) << "ERROR: Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl;
+    eLog() << Verbose(1) << "Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl;
     helper.ProjectOntoPlane(&CirclePlaneNormal);
   }
@@ -230,15 +236,15 @@
   // test whether the new center vector has length of CircleRadius
   if (fabs(radius - CircleRadius) > HULLEPSILON)
-    eLog() << Verbose(1) << "ERROR: The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
+    eLog() << Verbose(1) << "The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
   alpha = helper.Angle(&OldSphereCenter);
   // make the angle unique by checking the halfplanes/search direction
   if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)  // acos is not unique on [0, 2.*M_PI), hence extra check to decide between two half intervals
     alpha = 2.*M_PI - alpha;
-  //Log() << Verbose(2) << "INFO: RelativeNewSphereCenter is " << helper << ", RelativeOldSphereCenter is " << OldSphereCenter << " and resulting angle is " << alpha << "." << endl;
+  //Log() << Verbose(1) << "INFO: RelativeNewSphereCenter is " << helper << ", RelativeOldSphereCenter is " << OldSphereCenter << " and resulting angle is " << alpha << "." << endl;
   radius = helper.Distance(&OldSphereCenter);
   helper.ProjectOntoPlane(&NormalVector);
   // check whether new center is somewhat away or at least right over the current baseline to prevent intersecting triangles
   if ((radius > HULLEPSILON) || (helper.Norm() < HULLEPSILON)) {
-    //Log() << Verbose(2) << "INFO: Distance between old and new center is " << radius << " and between new center and baseline center is " << helper.Norm() << "." << endl;
+    //Log() << Verbose(1) << "INFO: Distance between old and new center is " << radius << " and between new center and baseline center is " << helper.Norm() << "." << endl;
     return alpha;
   } else {
@@ -263,4 +269,5 @@
 double MinIntersectDistance(const gsl_vector * x, void *params)
 {
+	Info FunctionInfo(__func__);
   double retval = 0;
   struct Intersection *I = (struct Intersection *)params;
@@ -283,5 +290,5 @@
 
   retval = HeightA.ScalarProduct(&HeightA) + HeightB.ScalarProduct(&HeightB);
-  //Log() << Verbose(2) << "MinIntersectDistance called, result: " << retval << endl;
+  //Log() << Verbose(1) << "MinIntersectDistance called, result: " << retval << endl;
 
   return retval;
@@ -303,4 +310,5 @@
 bool existsIntersection(const Vector &point1, const Vector &point2, const Vector &point3, const Vector &point4)
 {
+	Info FunctionInfo(__func__);
   bool result;
 
@@ -350,5 +358,5 @@
 
         if (status == GSL_SUCCESS) {
-          Log() << Verbose(2) << "converged to minimum" <<  endl;
+          Log() << Verbose(1) << "converged to minimum" <<  endl;
         }
     } while (status == GSL_CONTINUE && iter < 100);
@@ -375,13 +383,13 @@
   t2 = HeightB.ScalarProduct(&SideB)/SideB.ScalarProduct(&SideB);
 
-  Log() << Verbose(2) << "Intersection " << intersection << " is at "
+  Log() << Verbose(1) << "Intersection " << intersection << " is at "
     << t1 << " for (" << point1 << "," << point2 << ") and at "
     << t2 << " for (" << point3 << "," << point4 << "): ";
 
   if (((t1 >= 0) && (t1 <= 1)) && ((t2 >= 0) && (t2 <= 1))) {
-    Log() << Verbose(0) << "true intersection." << endl;
+    Log() << Verbose(1) << "true intersection." << endl;
     result = true;
   } else {
-    Log() << Verbose(0) << "intersection out of region of interest." << endl;
+    Log() << Verbose(1) << "intersection out of region of interest." << endl;
     result = false;
   }
@@ -406,4 +414,5 @@
 double GetAngle(const Vector &point, const Vector &reference, const Vector &OrthogonalVector)
 {
+	Info FunctionInfo(__func__);
   if (reference.IsZero())
     return M_PI;
@@ -417,5 +426,5 @@
   }
 
-  Log() << Verbose(4) << "INFO: " << point << " has angle " << phi << " with respect to reference " << reference << "." << endl;
+  Log() << Verbose(1) << "INFO: " << point << " has angle " << phi << " with respect to reference " << reference << "." << endl;
 
   return phi;
@@ -432,4 +441,5 @@
 double CalculateVolumeofGeneralTetraeder(const Vector &a, const Vector &b, const Vector &c, const Vector &d)
 {
+	Info FunctionInfo(__func__);
   Vector Point, TetraederVector[3];
   double volume;
@@ -455,4 +465,5 @@
 bool CheckLineCriteriaForDegeneratedTriangle(const BoundaryPointSet * const nodes[3])
 {
+	Info FunctionInfo(__func__);
   bool result = false;
   int counter = 0;
@@ -461,5 +472,8 @@
   for (int i=0;i<3;i++)
     for (int j=i+1; j<3; j++) {
-      if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
+      if (nodes[i] == NULL) {
+        Log() << Verbose(1) << "Node nr. " << i << " is not yet present." << endl;
+        result = true;
+      } else if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
         LineMap::const_iterator FindLine;
         pair<LineMap::const_iterator,LineMap::const_iterator> FindPair;
@@ -478,5 +492,5 @@
     }
   if ((!result) && (counter > 1)) {
-    Log() << Verbose(2) << "INFO: Degenerate triangle is ok, at least two, here " << counter << ", existing lines are used." << endl;
+    Log() << Verbose(1) << "INFO: Degenerate triangle is ok, at least two, here " << counter << ", existing lines are used." << endl;
     result = true;
   }
@@ -485,47 +499,48 @@
 
 
-/** Sort function for the candidate list.
- */
-bool SortCandidates(const CandidateForTesselation* candidate1, const CandidateForTesselation* candidate2)
-{
-  Vector BaseLineVector, OrthogonalVector, helper;
-  if (candidate1->BaseLine != candidate2->BaseLine) {  // sanity check
-    Log() << Verbose(0) << "ERROR: sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl;
-    //return false;
-    exit(1);
-  }
-  // create baseline vector
-  BaseLineVector.CopyVector(candidate1->BaseLine->endpoints[1]->node->node);
-  BaseLineVector.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
-  BaseLineVector.Normalize();
-
-  // create normal in-plane vector to cope with acos() non-uniqueness on [0,2pi] (note that is pointing in the "right" direction already, hence ">0" test!)
-  helper.CopyVector(candidate1->BaseLine->endpoints[0]->node->node);
-  helper.SubtractVector(candidate1->point->node);
-  OrthogonalVector.CopyVector(&helper);
-  helper.VectorProduct(&BaseLineVector);
-  OrthogonalVector.SubtractVector(&helper);
-  OrthogonalVector.Normalize();
-
-  // calculate both angles and correct with in-plane vector
-  helper.CopyVector(candidate1->point->node);
-  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
-  double phi = BaseLineVector.Angle(&helper);
-  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
-    phi = 2.*M_PI - phi;
-  }
-  helper.CopyVector(candidate2->point->node);
-  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
-  double psi = BaseLineVector.Angle(&helper);
-  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
-    psi = 2.*M_PI - psi;
-  }
-
-  Log() << Verbose(2) << *candidate1->point << " has angle " << phi << endl;
-  Log() << Verbose(2) << *candidate2->point << " has angle " << psi << endl;
-
-  // return comparison
-  return phi < psi;
-};
+///** Sort function for the candidate list.
+// */
+//bool SortCandidates(const CandidateForTesselation* candidate1, const CandidateForTesselation* candidate2)
+//{
+//	Info FunctionInfo(__func__);
+//  Vector BaseLineVector, OrthogonalVector, helper;
+//  if (candidate1->BaseLine != candidate2->BaseLine) {  // sanity check
+//    eLog() << Verbose(1) << "sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl;
+//    //return false;
+//    exit(1);
+//  }
+//  // create baseline vector
+//  BaseLineVector.CopyVector(candidate1->BaseLine->endpoints[1]->node->node);
+//  BaseLineVector.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  BaseLineVector.Normalize();
+//
+//  // create normal in-plane vector to cope with acos() non-uniqueness on [0,2pi] (note that is pointing in the "right" direction already, hence ">0" test!)
+//  helper.CopyVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  helper.SubtractVector(candidate1->point->node);
+//  OrthogonalVector.CopyVector(&helper);
+//  helper.VectorProduct(&BaseLineVector);
+//  OrthogonalVector.SubtractVector(&helper);
+//  OrthogonalVector.Normalize();
+//
+//  // calculate both angles and correct with in-plane vector
+//  helper.CopyVector(candidate1->point->node);
+//  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  double phi = BaseLineVector.Angle(&helper);
+//  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
+//    phi = 2.*M_PI - phi;
+//  }
+//  helper.CopyVector(candidate2->point->node);
+//  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  double psi = BaseLineVector.Angle(&helper);
+//  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
+//    psi = 2.*M_PI - psi;
+//  }
+//
+//  Log() << Verbose(1) << *candidate1->point << " has angle " << phi << endl;
+//  Log() << Verbose(1) << *candidate2->point << " has angle " << psi << endl;
+//
+//  // return comparison
+//  return phi < psi;
+//};
 
 /**
@@ -539,4 +554,5 @@
 TesselPoint* FindSecondClosestPoint(const Vector* Point, const LinkedCell* const LC)
 {
+	Info FunctionInfo(__func__);
   TesselPoint* closestPoint = NULL;
   TesselPoint* secondClosestPoint = NULL;
@@ -549,13 +565,13 @@
   for(int i=0;i<NDIM;i++) // store indices of this cell
     N[i] = LC->n[i];
-  Log() << Verbose(2) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+  Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
 
   LC->GetNeighbourBounds(Nlower, Nupper);
-  //Log() << Verbose(0) << endl;
+  //Log() << Verbose(1) << endl;
   for (LC->n[0] = Nlower[0]; LC->n[0] <= Nupper[0]; LC->n[0]++)
     for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
         const LinkedNodes *List = LC->GetCurrentCell();
-        //Log() << Verbose(3) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
+        //Log() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
         if (List != NULL) {
           for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
@@ -574,5 +590,5 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << ","
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << ","
             << LC->n[2] << " is invalid!" << endl;
         }
@@ -593,4 +609,5 @@
 TesselPoint* FindClosestPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC)
 {
+	Info FunctionInfo(__func__);
   TesselPoint* closestPoint = NULL;
   SecondPoint = NULL;
@@ -603,13 +620,13 @@
   for(int i=0;i<NDIM;i++) // store indices of this cell
     N[i] = LC->n[i];
-  Log() << Verbose(3) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+  Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
 
   LC->GetNeighbourBounds(Nlower, Nupper);
-  //Log() << Verbose(0) << endl;
+  //Log() << Verbose(1) << endl;
   for (LC->n[0] = Nlower[0]; LC->n[0] <= Nupper[0]; LC->n[0]++)
     for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
         const LinkedNodes *List = LC->GetCurrentCell();
-        //Log() << Verbose(3) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
+        //Log() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
         if (List != NULL) {
           for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
@@ -622,13 +639,13 @@
               distance = currentNorm;
               closestPoint = (*Runner);
-              //Log() << Verbose(2) << "INFO: New Nearest Neighbour is " << *closestPoint << "." << endl;
+              //Log() << Verbose(1) << "INFO: New Nearest Neighbour is " << *closestPoint << "." << endl;
             } else if (currentNorm < secondDistance) {
               secondDistance = currentNorm;
               SecondPoint = (*Runner);
-              //Log() << Verbose(2) << "INFO: New Second Nearest Neighbour is " << *SecondPoint << "." << endl;
+              //Log() << Verbose(1) << "INFO: New Second Nearest Neighbour is " << *SecondPoint << "." << endl;
             }
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << ","
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << ","
             << LC->n[2] << " is invalid!" << endl;
         }
@@ -636,5 +653,5 @@
   // output
   if (closestPoint != NULL) {
-    Log() << Verbose(2) << "Closest point is " << *closestPoint;
+    Log() << Verbose(1) << "Closest point is " << *closestPoint;
     if (SecondPoint != NULL)
       Log() << Verbose(0) << " and second closest is " << *SecondPoint;
@@ -652,4 +669,5 @@
 Vector * GetClosestPointBetweenLine(const BoundaryLineSet * const Base, const BoundaryLineSet * const OtherBase)
 {
+	Info FunctionInfo(__func__);
   // construct the plane of the two baselines (i.e. take both their directional vectors)
   Vector Normal;
@@ -662,5 +680,5 @@
   Normal.VectorProduct(&OtherBaseline);
   Normal.Normalize();
-  Log() << Verbose(4) << "First direction is " << Baseline << ", second direction is " << OtherBaseline << ", normal of intersection plane is " << Normal << "." << endl;
+  Log() << Verbose(1) << "First direction is " << Baseline << ", second direction is " << OtherBaseline << ", normal of intersection plane is " << Normal << "." << endl;
 
   // project one offset point of OtherBase onto this plane (and add plane offset vector)
@@ -679,5 +697,5 @@
   Normal.CopyVector(Intersection);
   Normal.SubtractVector(Base->endpoints[0]->node->node);
-  Log() << Verbose(3) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(&Baseline)/Baseline.NormSquared()) << "." << endl;
+  Log() << Verbose(1) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(&Baseline)/Baseline.NormSquared()) << "." << endl;
 
   return Intersection;
@@ -692,4 +710,5 @@
 double DistanceToTrianglePlane(const Vector *x, const BoundaryTriangleSet * const triangle)
 {
+	Info FunctionInfo(__func__);
   double distance = 0.;
   if (x == NULL) {
@@ -708,4 +727,5 @@
 void WriteVrmlFile(ofstream * const vrmlfile, const Tesselation * const Tess, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   TesselPoint *Walker = NULL;
   int i;
@@ -738,5 +758,5 @@
     }
   } else {
-    eLog() << Verbose(0) << "ERROR: Given vrmlfile is " << vrmlfile << "." << endl;
+    eLog() << Verbose(1) << "Given vrmlfile is " << vrmlfile << "." << endl;
   }
   delete(center);
@@ -751,19 +771,23 @@
 void IncludeSphereinRaster3D(ofstream * const rasterfile, const Tesselation * const Tess, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   Vector helper;
-  // include the current position of the virtual sphere in the temporary raster3d file
-  Vector *center = cloud->GetCenter();
-  // make the circumsphere's center absolute again
-  helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
-  helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
-  helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
-  helper.Scale(1./3.);
-  helper.SubtractVector(center);
-  // and add to file plus translucency object
-  *rasterfile << "# current virtual sphere\n";
-  *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
-  *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
-  *rasterfile << "9\n  terminating special property\n";
-  delete(center);
+
+  if (Tess->LastTriangle != NULL) {
+    // include the current position of the virtual sphere in the temporary raster3d file
+    Vector *center = cloud->GetCenter();
+    // make the circumsphere's center absolute again
+    helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
+    helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
+    helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
+    helper.Scale(1./3.);
+    helper.SubtractVector(center);
+    // and add to file plus translucency object
+    *rasterfile << "# current virtual sphere\n";
+    *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
+    *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
+    *rasterfile << "9\n  terminating special property\n";
+    delete(center);
+  }
 };
 
@@ -776,4 +800,5 @@
 void WriteRaster3dFile(ofstream * const rasterfile, const Tesselation * const Tess, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   TesselPoint *Walker = NULL;
   int i;
@@ -808,5 +833,5 @@
     *rasterfile << "9\n#  terminating special property\n";
   } else {
-    eLog() << Verbose(0) << "ERROR: Given rasterfile is " << rasterfile << "." << endl;
+    eLog() << Verbose(1) << "Given rasterfile is " << rasterfile << "." << endl;
   }
   IncludeSphereinRaster3D(rasterfile, Tess, cloud);
@@ -821,11 +846,17 @@
 void WriteTecplotFile(ofstream * const tecplot, const Tesselation * const TesselStruct, const PointCloud * const cloud, const int N)
 {
+	Info FunctionInfo(__func__);
   if ((tecplot != NULL) && (TesselStruct != NULL)) {
     // write header
     *tecplot << "TITLE = \"3D CONVEX SHELL\"" << endl;
     *tecplot << "VARIABLES = \"X\" \"Y\" \"Z\" \"U\"" << endl;
-    *tecplot << "ZONE T=\"" << N << "-";
-    for (int i=0;i<3;i++)
-      *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+    *tecplot << "ZONE T=\"";
+    if (N < 0) {
+      *tecplot << cloud->GetName();
+    } else {
+      *tecplot << N << "-";
+      for (int i=0;i<3;i++)
+        *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+    }
     *tecplot << "\", N=" << TesselStruct->PointsOnBoundary.size() << ", E=" << TesselStruct->TrianglesOnBoundary.size() << ", DATAPACKING=POINT, ZONETYPE=FETRIANGLE" << endl;
     int i=0;
@@ -836,5 +867,4 @@
 
     // print atom coordinates
-    Log() << Verbose(2) << "The following triangles were created:";
     int Counter = 1;
     TesselPoint *Walker = NULL;
@@ -846,10 +876,10 @@
     *tecplot << endl;
     // print connectivity
+    Log() << Verbose(1) << "The following triangles were created:" << endl;
     for (TriangleMap::const_iterator runner = TesselStruct->TrianglesOnBoundary.begin(); runner != TesselStruct->TrianglesOnBoundary.end(); runner++) {
-      Log() << Verbose(0) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name;
+      Log() << Verbose(1) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name << endl;
       *tecplot << LookupList[runner->second->endpoints[0]->node->nr] << " " << LookupList[runner->second->endpoints[1]->node->nr] << " " << LookupList[runner->second->endpoints[2]->node->nr] << endl;
     }
     delete[] (LookupList);
-    Log() << Verbose(0) << endl;
   }
 };
@@ -862,8 +892,8 @@
 void CalculateConcavityPerBoundaryPoint(const Tesselation * const TesselStruct)
 {
+	Info FunctionInfo(__func__);
   class BoundaryPointSet *point = NULL;
   class BoundaryLineSet *line = NULL;
 
-  //Log() << Verbose(2) << "Begin of CalculateConcavityPerBoundaryPoint" << endl;
   // calculate remaining concavity
   for (PointMap::const_iterator PointRunner = TesselStruct->PointsOnBoundary.begin(); PointRunner != TesselStruct->PointsOnBoundary.end(); PointRunner++) {
@@ -873,10 +903,9 @@
     for (LineMap::iterator LineRunner = point->lines.begin(); LineRunner != point->lines.end(); LineRunner++) {
       line = LineRunner->second;
-      //Log() << Verbose(2) << "INFO: Current line of point " << *point << " is " << *line << "." << endl;
+      //Log() << Verbose(1) << "INFO: Current line of point " << *point << " is " << *line << "." << endl;
       if (!line->CheckConvexityCriterion())
         point->value += 1;
     }
   }
-  //Log() << Verbose(2) << "End of CalculateConcavityPerBoundaryPoint" << endl;
 };
 
@@ -889,4 +918,5 @@
 bool CheckListOfBaselines(const Tesselation * const TesselStruct)
 {
+	Info FunctionInfo(__func__);
   LineMap::const_iterator testline;
   bool result = false;
@@ -896,5 +926,5 @@
   for (testline = TesselStruct->LinesOnBoundary.begin(); testline != TesselStruct->LinesOnBoundary.end(); testline++) {
     if (testline->second->triangles.size() != 2) {
-      Log() << Verbose(1) << *testline->second << "\t" << testline->second->triangles.size() << endl;
+      Log() << Verbose(2) << *testline->second << "\t" << testline->second->triangles.size() << endl;
       counter++;
     }
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/unittests/Makefile.am	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -4,5 +4,5 @@
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
 
-TESTS = ActOnAllUnitTest AnalysisBondsUnitTests AnalysisCorrelationToPointUnitTest AnalysisCorrelationToSurfaceUnitTest AnalysisPairCorrelationUnitTest BondGraphUnitTest ListOfBondsUnitTest LogUnitTest MemoryUsageObserverUnitTest MemoryAllocatorUnitTest StackClassUnitTest VectorUnitTest
+TESTS = ActOnAllUnitTest AnalysisBondsUnitTests AnalysisCorrelationToPointUnitTest AnalysisCorrelationToSurfaceUnitTest AnalysisPairCorrelationUnitTest BondGraphUnitTest InfoUnitTest ListOfBondsUnitTest LogUnitTest MemoryUsageObserverUnitTest MemoryAllocatorUnitTest StackClassUnitTest VectorUnitTest
 check_PROGRAMS = $(TESTS)
 noinst_PROGRAMS = $(TESTS)
@@ -25,4 +25,7 @@
 BondGraphUnitTest_SOURCES = bondgraphunittest.cpp bondgraphunittest.hpp
 BondGraphUnitTest_LDADD = ../libmolecuilder.a
+
+InfoUnitTest_SOURCES = infounittest.cpp infounittest.hpp
+InfoUnitTest_LDADD = ../libmolecuilder.a
 
 ListOfBondsUnitTest_SOURCES = listofbondsunittest.cpp listofbondsunittest.hpp
Index: src/unittests/infounittest.cpp
===================================================================
--- src/unittests/infounittest.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
+++ src/unittests/infounittest.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -0,0 +1,66 @@
+/*
+ * InfoUnitTest.cpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <iostream>
+#include <stdio.h>
+
+#include "info.hpp"
+#include "infounittest.hpp"
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( InfoTest );
+
+
+void InfoTest::setUp()
+{
+};
+
+
+void InfoTest::tearDown()
+{
+};
+
+/** UnitTest for FunctionTest().
+ */
+void InfoTest::FunctionTest()
+{
+  const char *msg = __func__;
+  class Info test(msg);
+
+  CPPUNIT_ASSERT_EQUAL( msg , test.FunctionName );
+  CPPUNIT_ASSERT_EQUAL( 1, test.verbosity );
+};
+
+
+/********************************************** Main routine **************************************/
+
+int main(int argc, char **argv)
+{
+  // Get the top level suite from the registry
+  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();
+
+  // Adds the test to the list of test to run
+  CppUnit::TextUi::TestRunner runner;
+  runner.addTest( suite );
+
+  // Change the default outputter to a compiler error format outputter
+  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
+                                                       std::cerr ) );
+  // Run the tests.
+  bool wasSucessful = runner.run();
+
+  // Return error code 1 if the one of test failed.
+  return wasSucessful ? 0 : 1;
+};
Index: src/unittests/infounittest.hpp
===================================================================
--- src/unittests/infounittest.hpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
+++ src/unittests/infounittest.hpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -0,0 +1,32 @@
+/*
+ * InfoUnitTest.hpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+#ifndef INFOUNITTEST_HPP_
+#define INFOUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class info;
+
+/********************************************** Test classes **************************************/
+
+class InfoTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( InfoTest) ;
+    CPPUNIT_TEST ( FunctionTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void FunctionTest();
+
+private:
+
+};
+
+#endif /* INFOUNITTEST_HPP_ */
